Type Laser Extends OwnerSpark
	Method collided(damage: Float)'p: Point)
		health = 0
		Explosion.create(x, y, 5, 2, 100)
	End Method
	
	Method getType: Int()
		Return SOT_LASER
	End Method
	
	Function create: Laser(owner: SpaceObject, x: Float, y: Float, xscale: Float, yscale: Float, r: int, g: int, b: int, lifetime: Float, rot: Float, speed: Float, collisionradius: Float = 0, collisiondamage: Float = 0, health: Float = 0)
		Local l:Laser = New Laser
		
		l.x = x
		l.y = y
		
		l.owner = owner
		
		l.xscale = xscale
		l.yscale = yscale
		
		l.xd = Cos(rot) * speed
		l.yd = Sin(rot) * speed
		
		l.rotation = rot
		
		l.lifetime = lifetime
		
		l.r = r
		l.g = g
		l.b = b
		
		l.collisiondamage = collisiondamage
		l.collisionradius = collisionradius
		l.health = health
		
		l.alpha = 1
		
		Return l
	End Function
End Type
