Type Weapon
	Field r: Int, g: Int, b: Int
	Field speed: Float
	Field strengh: Float
	Field shotrate: Int
	Field lls: Int
	Field xscale: Float, yscale: Float
	Field owner: Ship
	Field x: Float, y: Float
	Field energy: Float
	
	Method New()
		lls = MilliSecs()
	End Method
	
	Function create: Weapon(owner: Ship, x: Float, y: Float, r: Int, g: Int, b: Int, speed: Float, strengh: Float, shotrate: Int, xscale: Float, yscale: Float, energy: Float)
		Local wp: Weapon = New Weapon
		
		wp.owner = owner
		
		wp.x = x
		wp.y = y
		
		wp.r = r
		wp.g = g
		wp.b = b
		
		wp.speed = speed
		wp.strengh = strengh
		wp.shotrate = shotrate
		
		wp.xscale = xscale
		wp.yscale = yscale
		
		wp.energy = energy
		
		Return wp
	End Function
	
	Method shoot(x: Int, y: Int, rotation: Float, addspeed: Float)
		If MilliSecs()-lls > shotrate Then
			If owner.energy >= energy
				lls = MilliSecs()
				Laser.create(owner, x+cos(rotation)*self.x+cos(rotation+90)*self.y, y+sin(rotation)*self.x+sin(rotation+90)*self.y, xscale, yscale, r, g, b, 0.1, rotation, speed+addspeed, 3, 100, 1)
				owner.energy :- energy
			End If
		End If
	End Method
End Type
